<template>
    <div v-if="popup.colors">
        <div
            v-for="(offer, index) in popup.growth_offers"
            :key="index"
            class="form-group form-inline edit__set_block white-space full-width"
        >
            <div
                v-if="offer.order === 1"
                class="pointer full-width"
                @click="changeStatus(offer.order)"
            >
                <span class="offer-text">{{ getText(offer.order) }}</span>
                <span
                    v-if="isHidden[offer.order-1].active"
                    class="right"
                >
                    <svg
                        xmlns="http://www.w3.org/2000/svg"
                        width="11"
                        height="9"
                        viewBox="0 0 10.828 6.414"
                    >
                        <path
                            id="chevron-down"
                            d="M6,13l4-4,4,4"
                            transform="translate(-4.586 -8)"
                            fill="none"
                            stroke="#4786ff"
                            stroke-linecap="round"
                            stroke-linejoin="round"
                            stroke-width="2" 
                        />
                    </svg>
                </span>
                <span
                    v-else
                    class="right"
                >
                    <svg
                        xmlns="http://www.w3.org/2000/svg"
                        width="11"
                        height="9"
                        viewBox="0 0 10.828 6.414"
                    >
                        <path
                            id="chevron-down"
                            d="M6,13l4-4,4,4"
                            transform="translate(15.414 14.414) rotate(180)"
                            fill="none"
                            stroke="#99a1a7"
                            stroke-linecap="round"
                            stroke-linejoin="round"
                            stroke-width="2" 
                        />
                    </svg>
                </span>
            </div>
            <div
                v-if="offer.order !== 1"
                class="pointer full-width"
                @click="changeStatus(offer.order)"
            >
                <span class="offer-text">{{ getText(offer.order) }}</span>
                <span
                    v-if="isHidden[offer.order-1].active"
                    class="right"
                >
                    <toggle-button
                        ref="status"
                        v-model="offer.status"
                        :disabled="toggleActive[offer.order -1]"
                        :sync="true"
                        :labels="true"
                        color="#2d77f5"
                        :height="24"
                        style="margin: 0 15px 0 0"
                        @change="setFalse(offer.order)" 
                    />
                    <svg
                        xmlns="http://www.w3.org/2000/svg"
                        width="11"
                        height="9"
                        viewBox="0 0 10.828 6.414"
                    >
                        <path
                            id="chevron-down"
                            d="M6,13l4-4,4,4"
                            transform="translate(-4.586 -8)"
                            fill="none"
                            stroke="#4786ff"
                            stroke-linecap="round"
                            stroke-linejoin="round"
                            stroke-width="2" 
                        />
                    </svg>
                </span>
                <span
                    v-else
                    class="right"
                >
                    <toggle-button
                        v-model="offer.status"
                        :sync="true"
                        :labels="true"
                        color="#2d77f5"
                        :height="24"
                        style="margin: 0 15px 0 0"
                        @change="setFalse(offer.order)" 
                    />
                    <span>
                        <svg
                            xmlns="http://www.w3.org/2000/svg"
                            width="11"
                            height="9"
                            viewBox="0 0 10.828 6.414"
                        >
                            <path
                                id="chevron-down"
                                d="M6,13l4-4,4,4"
                                transform="translate(15.414 14.414) rotate(180)"
                                fill="none"
                                stroke="#99a1a7"
                                stroke-linecap="round"
                                stroke-linejoin="round"
                                stroke-width="2" 
                            />
                        </svg>
                    </span>
                </span>
            </div>
            <div v-show="isHidden[offer.order-1].active">
                <div
                    v-if="(popup.growth_offers[offer.order>2?offer.order-2:0].optin_channel != 'any' &&
                        popup.growth_offers[0].optin_channel != 'any')
                        || offer.order === 1"
                    class="full-width"
                >
                    <br>
                    <h4>Optin Channel</h4>
                    <div class="form-inline">
                        <select
                            v-model="offer.optin_channel"
                            class="form-control full-width my-select-menu custom-select"
                            @change="setValue"
                        >
                            <option
                                value="any"
                            >
                                Any
                            </option>
                            <option
                                v-if="canChannelUse(offer.order - 1, 'email')"
                                value="email"
                            >
                                Email
                            </option>
                            <option
                                v-if="canChannelUse(offer.order - 1, 'sms')"
                                value="sms"
                            >
                                Sms
                            </option>
                            <option
                                v-if="canChannelUse(offer.order - 1, 'push')"
                                value="push"
                            >
                                Push
                            </option>
                        </select>
                    </div>
                </div>
                <br>
                <h4>Offer Text</h4>
                <div class="row">
                    <div class="col-12 mb-2 col-md-6">
                        <select
                            v-model="tag"
                            class="form-control full-width my-select-menu custom-select"
                            @change="changeTag"
                        >
                            <option value="tags">
                                tags
                            </option>
                            <option
                                v-if="offer.automatic_discount_enabled==1"
                                value="{discountValue}"
                            >
                                {discountValue}
                            </option>
                        </select>
                    </div>
                </div>
                <br>
                <div class="form-inline">
                    <validation-element
                        id="text"
                        v-model="offer.offer_text"
                        type="textarea"
                        name="Offer text"
                        :rows="5"
                        custom-input-class="form-control"
                        @focus="focus($event, offer.order)"
                    />
                </div>
                <br>
                <div class="form-inline">
                    <validation-element
                        id="validation-input"
                        v-model="offer.placeholder_text"
                        label="Placeholder text"
                        :rules="''"
                        custom-input-class="form-control"
                        custom-label-class="label_light"
                    />
                </div>
                <br>
                <div class="form-inline">
                    <validation-element
                        id="validation-input"
                        v-model="popup.validation_text"
                        label="Error Text"
                        custom-input-class="form-control"
                        custom-label-class="label_light"
                    />
                </div>
                <br>
                <div class="row">
                    <div class="col-12 mb-2 col-md-6">
                        <div class="title-text label_light">
                            Text Color
                        </div>
                        <div class="jscolor-group">
                            <input
                                id="settings-title-color"
                                v-model="offer.text_color"
                                data-vv-as="Header Color"
                                type="text"
                                class="form-control full-width"
                            >
                            <button
                                id="btn-color-picker"
                                :style="{background: offer.text_color}"
                                class="btn btn-color"
                                type="button"
                                @click="showPicker(offer.order)"
                            />
                            <div
                                v-show="textColor[offer.order - 1].active"
                                class="chrome-picker"
                            >
                                <chrome-picker v-model="text" />
                            </div>
                        </div>
                    </div>
                    <div
                        v-if="!showNewModal"
                        class="col-md-6"
                    >
                        <div class="title-text label_light">
                            Background Color
                        </div>
                        <div class="jscolor-group">
                            <input
                                id="settings-background-color"
                                v-model="offer.background_color"
                                data-vv-as="Header Color"
                                type="text"
                                class="form-control full-width"
                            >
                            <button
                                id="btn-background-picker"
                                :style="{background: offer.background_color}"
                                class="btn btn-color"
                                type="button"
                                @click="showBackgroundColorPicker(offer.order)"
                            />
                            <div
                                v-show="backgroundColor[offer.order - 1].active"
                                class="chrome-picker"
                            >
                                <chrome-picker v-model="bgColor" />
                            </div>
                        </div>
                    </div>
                </div>
                <br>
                <div
                    v-if="showNewModal"
                    class="row"
                >
                    <div class="col-12 mb-2 col-md-6">
                        <div class="title-text label_light">
                            Offer Background Color
                        </div>
                        <div class="jscolor-group">
                            <input
                                id="settings-icon-color"
                                v-model="offer.offer_background_color"
                                data-vv-as="Offer Background Icon Color"
                                type="text"
                                class="form-control full-width"
                            >
                            <button
                                id="offer-background-color"
                                :style="{background: offer.offer_background_color}"
                                class="btn btn-color offer-background-color"
                                type="button"
                                @click="showOfferBackgroundColorPicker(offer.order)"
                            />
                            <div
                                v-show="offerBackgroundColor[offer.order - 1].active"
                                class="chrome-picker"
                            >
                                <chrome-picker v-model="offerBackground" />
                            </div>
                        </div>
                    </div>
                    <div class="col-12 mb-2 col-md-6">
                        <div class="title-text label_light">
                            Offer Text Color
                        </div>
                        <div class="jscolor-group">
                            <input
                                id="settings-icon-color"
                                v-model="offer.offer_text_color"
                                data-vv-as="Offer Icon Color"
                                type="text"
                                class="form-control full-width"
                            >
                            <button
                                id="offer-icon-color"
                                :style="{background: offer.offer_text_color}"
                                class="btn btn-color"
                                type="button"
                                @click="showOfferTextColorPicker(offer.order)"
                            />
                            <div
                                v-show="offerTextColor[offer.order - 1].active"
                                class="chrome-picker"
                            >
                                <chrome-picker v-model="offerText" />
                            </div>
                        </div>
                    </div>
                </div>
                <br>
                <div class="row">
                    <div class="col-12 mb-2 col-md-6">
                        <div class="title-text label_light">
                            Background Icon Color
                        </div>
                        <div class="jscolor-group">
                            <input
                                id="settings-icon-color"
                                v-model="offer.icon_background_color"
                                data-vv-as="Background Icon Color"
                                type="text"
                                class="form-control full-width"
                            >
                            <button
                                id="background-icon-color"
                                :style="{background: offer.icon_background_color}"
                                class="btn btn-color"
                                type="button"
                                @click="showBackgroundIconPicker(offer.order)"
                            />
                            <div
                                v-show="backgroundIconColor[offer.order - 1].active"
                                class="chrome-picker"
                            >
                                <chrome-picker v-model="backgroundIcon" />
                            </div>
                        </div>
                    </div>
                    <div
                        class="col-12 mb-2 col-md-6"
                    >
                        <div class="title-text label_light">
                            Icon Color
                        </div>
                        <div class="jscolor-group">
                            <input
                                id="settings-icon-color"
                                v-model="offer.icon_color"
                                data-vv-as="Icon Color"
                                type="text"
                                class="form-control full-width"
                            >
                            <button
                                id="icon-color"
                                :style="{background: offer.icon_color}"
                                class="btn btn-color"
                                type="button"
                                @click="showIconPicker(offer.order)"
                            />
                            <div
                                v-show="iconColor[offer.order - 1].active"
                                class="chrome-picker"
                            >
                                <chrome-picker v-model="icon" />
                            </div>
                        </div>
                    </div>
                </div>
                <br>
                <div class="row">
                    <div class="col-12 mb-2 col-md-6">
                        <validation-element
                            v-model="offer.subscribed_text"
                            label="Subscribed Text:"
                            name="Subscribed Text"
                            custom-label-class="label_light"
                            custom-input-class="form-control "
                        />
                    </div>
                </div>
                <br><br>
                <h4>Discount</h4>
                <div class="row">
                    <div class="col-12 mb-2 col-md-6">
                        <div class="">
                            Type
                        </div>
                        <select
                            :id="'code-' + offer.order"
                            v-model="offer.automatic_discount_enabled"
                            style="background-color: white;"
                            :name="'automatic_discount_enabled'"
                            data-vv-as="Discount Type"
                            type="text"
                            class="form-control full-width my-select-menu custom-select"
                        >
                            <option value="0">
                                Pre-made
                            </option>
                            <option value="1">
                                Automatic
                            </option>
                        </select>
                    </div>
                    <div class="col-12 mb-2 col-md-6">
                        <div
                            v-if="offer.automatic_discount_enabled==0"
                            class="mb-4"
                        >
                            <div>
                                <div>
                                    <validation-element
                                        :id="'code-' + offer.order"
                                        v-model="offer.code"
                                        label="Discount Code"
                                        :name="'code'"
                                        data-vv-as="Discount Code"
                                        custom-label-class="label_light"
                                        custom-input-class="form-control"
                                    />
                                </div>
                            </div>
                        </div>
                        <div>
                            <div class="form control">
                                <div>
                                    <div>
                                        <validation-element
                                            :id="'code-' + offer.order"
                                            v-model="offer.automatic_discount_value"
                                            label="Discount %"
                                            custom-label-class="label_light"
                                            :name="'automatic_discount_value'"
                                            data-vv-as="Discount"
                                            custom-input-class="form-control"
                                        />
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <br>
                <h4>Thank You Message</h4>
                <br>
                <div class="row">
                    <div class="col-12 mb-2 col-md-6">
                        <select
                            v-model="tag"
                            class="form-control full-width my-select-menu custom-select"
                            @change="changeTag"
                        >
                            <option value="tags">
                                tags
                            </option>
                            <option
                                v-if="offer.automatic_discount_enabled==1"
                                value="{discountValue}"
                            >
                                {discountValue}
                            </option>
                            <option value="{discountCode}">
                                {discountCode}
                            </option>
                        </select>
                    </div>
                    <div class="col-12 mb-2 col-md-6">
                        <button
                            v-if="!showThank[offer.order -1].active"
                            type="button"
                            class="btn btn-secondary right"
                            @click="showThankText(offer.order - 1)"
                        >
                            Preview
                        </button>
                        <button
                            v-else
                            type="button"
                            class="btn btn-secondary right"
                            @click="showThankText(offer.order - 1)"
                        >
                            Hide Preview
                        </button>
                    </div>
                </div>
                <br>
                <div class="form-inline">
                    <validation-element
                        id="thank_message"
                        v-model="offer.thank_message"
                        type="textarea"
                        custom-input-class="form-control"
                        name="thank message"
                        :rows="5"
                        @focus="focus($event, offer.order)"
                    />
                </div>
                <br>
                <div class="row">
                    <div class="col-12 mb-2 col-md-6">
                        <div>
                            <validation-element
                                :id="'btn_text' + offer.id"
                                v-model="offer.btn_text"
                                label="Button Text"
                                custom-label-class="label_light"
                                custom-input-class="form-control"
                            />
                        </div>
                    </div>
                </div>
                <br>
                <div class="row">
                    <div class="col-12 mb-2 col-md-6">
                        <div class="full-width">
                            <div class="title-text">
                                Button Color
                            </div>
                            <div class="jscolor-group">
                                <input
                                    :id="'btn-color' + offer.id"
                                    v-model="offer.btn_color"
                                    data-vv-as="Header Color"
                                    type="text"
                                    class="form-control full-width"
                                >
                                <button
                                    :style="{background: offer.btn_color}"
                                    class="btn btn-color second-type"
                                    type="button"
                                    @click="showBtnPicker(offer.order)"
                                />
                                <div
                                    v-show="btnColor[offer.order - 1].active"
                                    class="chrome-picker"
                                >
                                    <chrome-picker v-model="btn" />
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="col-12 mb-2 col-md-6">
                        <div class="full-width">
                            <div class="title-text">
                                Button Text Color
                            </div>
                            <div class="jscolor-group">
                                <input
                                    :id="'btn-text-color' + offer.id"
                                    v-model="offer.btn_text_color"
                                    data-vv-as="Header Color"
                                    type="text"
                                    class="form-control full-width"
                                >
                                <button
                                    :style="{background: offer.btn_text_color}"
                                    class="btn btn-color text-type"
                                    type="button"
                                    @click="showBtnTextPicker(offer.order)"
                                />
                                <div
                                    v-show="btnTextColor[offer.order - 1].active"
                                    class="chrome-picker"
                                >
                                    <chrome-picker v-model="btnText" />
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import {Chrome} from 'vue-color';
import ValidationElement from '../elements/ValidationElement.vue';

export default {
    name: "Offers",
    components: {
        'chrome-picker': Chrome,
        ValidationElement,
  
    },
    props: {
        popup: Object,
        showThank: Array,
        showNewModal: Boolean,
    },
    data() {
        return {
            toggleActive: [false, false, false],
            status: this.popup.growth_offers,
            textColor: [
                {active: false},
                {active: false},
                {active: false}
            ],
            btnColor: [
                {active: false},
                {active: false},
                {active: false}
            ],
            backgroundColor: [
                {active: false},
                {active: false},
                {active: false}
            ],
            iconColor: [
                {active: false},
                {active: false},
                {active: false}
            ],
            backgroundIconColor: [
                {active: false},
                {active: false},
                {active: false}
            ],
            offerBackgroundColor: [
                {active: false},
                {active: false},
                {active: false}
            ],
            offerTextColor: [
                {active: false},
                {active: false},
                {active: false}
            ],
            offerTextColorArr: [
                {active: false},
                {active: false},
                {active: false}
            ],
            btnTextColor: [
                {active: false},
                {active: false},
                {active: false}
            ],
            isHidden: [
                {active: true},
                {active: true},
                {active: true}
            ],
            text: '',
            icon: '',
            backgroundIcon: '',
            offerBackground: '',
            offerText: '',
            // offerIcon: '',
            btn: '',
            bgColor: '',
            btnText: '',
            order: 0,
            focused: '',
            tag: 'tags',
            activeCount: 0,
        }
    },
    watch: {
        popup: {
            deep: true,
            handler() {
                this.setActiveCount();
            }
        },
        activeCount: {
            deep: true,
            handler() {
                this.setValue();
            }
        },
        text: {
            deep: true,
            handler() {
                this.popup.growth_offers[this.order].text_color = this.text.hex;
            }
        },
        bgColor: {
            deep: true,
            handler() {
                this.popup.growth_offers[this.order].background_color = this.bgColor.hex;
            }
        },
        icon: {
            deep: true,
            handler() {
                this.popup.growth_offers[this.order].icon_color = this.icon.hex;
            }
        },
        backgroundIcon: {
           deep: true,
            handler() {
                this.popup.growth_offers[this.order].icon_background_color = this.backgroundIcon.hex;
            } 
        },
        offerBackground: {
           deep: true,
            handler() {
                this.popup.growth_offers[this.order].offer_background_color = this.offerBackground.hex;
            } 
        },
        // offerIcon: {
        //     deep: true,
        //     handler() {
        //         this.popup.growth_offers[this.order].offer_text_color = this.offerIcon.hex;
        //     } 
        // },
        offerText: {
           deep: true,
            handler() {
                this.popup.growth_offers[this.order].offer_text_color = this.offerText.hex;
            } 
        },        
        btn: {
            deep: true,
            handler() {
                this.popup.growth_offers[this.order].btn_color = this.btn.hex;
            }
        },
        btnText: {
            deep: true,
            handler() {
                this.popup.growth_offers[this.order].btn_text_color = this.btnText.hex;
            }
        },
    },
    mounted() {
        this.setActiveCount();
    },
    methods: {
        showThankText(index) {
            this.showThank[index].active = !this.showThank[index].active
        },
        setActiveCount() {
            this.activeCount = 0;

            const CHANNELS = ['email', 'sms', 'push']
            const CHANNELS_PLACEHOLDER_VALUE = { email: 'Your email address', sms:  'Your phone number', push: 'Push notification' }

            this.popup.growth_offers.forEach((item, index) => {
                if (item.status) {
                    this.activeCount++;
                }


                if(item.placeholder_text == null) {
                    const CHANNEL = item.optin_channel

                    const IS_ANY = CHANNEL == 'any'
                    const TYPE = IS_ANY ? CHANNELS[index] : CHANNELS[CHANNELS.indexOf(CHANNEL)]
                    
                    item.placeholder_text = CHANNELS_PLACEHOLDER_VALUE[TYPE]
                }
            })
        },
        focus(e, order) {
            console.log(e, order, e.target)
            this.focused = e.target;
            this.selectedOrder = order - 1;
        },
        changeTag() {
            if (this.focused) {
                if (this.focused.id !== 'text') {
                    this.popup.growth_offers[this.selectedOrder].thank_message = this.popup.growth_offers[this.selectedOrder].thank_message.slice(0, this.focused.selectionStart)
                        + `${this.tag}` + this.popup.growth_offers[this.selectedOrder].thank_message.slice(this.focused.selectionStart);
                } else {
                    this.popup.growth_offers[this.selectedOrder].offer_text = this.popup.growth_offers[this.selectedOrder].offer_text.slice(0, this.focused.selectionStart)
                        + `${this.tag}` + this.popup.growth_offers[this.selectedOrder].offer_text.slice(this.focused.selectionStart);
                }
                this.focused.focus();
                this.focused.parentElement.classList.remove('has-error')
                this.tag = 'tags'
            } else {
                this.tag = 'tags'
            }
        },
        setValue() {
            const allValues = ['email', 'sms', 'push']
            const newPosition = []
            for (let i = 0; i < 3; i++) {
                if (allValues.indexOf(this.popup.growth_offers[i].optin_channel) === -1
                    && this.popup.growth_offers[i].optin_channel !== 'any') {
                    this.popup.growth_offers[i].optin_channel = allValues[0];
                    newPosition.push(allValues[0])
                } else if(this.popup.growth_offers[i].optin_channel !== 'any') {
                    let index = allValues.indexOf(this.popup.growth_offers[i].optin_channel)
                    newPosition.push(allValues[index])
                }
                else {
                    newPosition.push(allValues[i])
                    for (let k = i; k < 3; k++) {
                        this.popup.growth_offers[k].optin_channel = 'any';
                    }
                }
            }
        },
        setFalse(order) {
            if (this.popup.growth_offers[order - 1].status === false) {
                for (let i = order - 1; i < 3; i++) {
                    this.popup.growth_offers[i].status = false
                    this.toggleActive[i + 1] = true
                }
            } else {
                for (let i = order - 1; i < 4; i++) {
                    this.toggleActive[i + 1] = false
                }
            }
        },
        canChannelUse(order, type) {
            let canUse = true;
            for (let i = 0; i < order; i++) {
                if (this.popup.growth_offers[i].optin_channel === type) {
                    canUse = false;
                }
            }
            return canUse;
        },
        changeStatus(order) {
            this.isHidden[order - 1].active = !this.isHidden[order - 1].active;
        },
        getText(order) {
            switch (order) {
                case 1 :
                    return 'First Offer'
                case 2 :
                    return 'Second Offer'
                case 3 :
                    return 'Third Offer'
                case 4 :
                    return 'Fourth Offer'
            }
        },
        showPicker(order) {
            this.order = order - 1;
            this.hideAll()
            document.addEventListener('click', this.documentClick);

            this.textColor[order - 1].active = true;
        },
        hidePicker() {
            document.removeEventListener('click', this.documentClick);

            this.textColor[0].active = false;
            this.textColor[1].active = false;
            this.textColor[2].active = false;

        },
        showBtnPicker(order) {
            this.order = order - 1;
            this.hideAll()
            document.addEventListener('click', this.documentBtnClick);

            this.btnColor[order - 1].active = true;
        },
        hideBtnPicker() {
            document.removeEventListener('click', this.documentBtnClick);

            this.btnColor[0].active = false;
            this.btnColor[1].active = false;
            this.btnColor[2].active = false;
        },
        showIconPicker(order) {
            this.order = order - 1;
            this.hideAll()
            document.addEventListener('click', this.documentIconClick);

            this.iconColor[order - 1].active = true;
        },
        showBackgroundIconPicker(order) {
            this.order = order - 1;
            this.hideAll()
            document.addEventListener('click', this.documentBackgroundIconClick);

            this.backgroundIconColor[order - 1].active = true;
        },
        showOfferTextColorPicker(order) {
            this.order = order - 1;
            this.hideAll()
            document.addEventListener('click', this.documentOfferTextColorClick);

            this.offerTextColor[order - 1].active = true;
        },
        showOfferBackgroundColorPicker(order) {
            this.order = order - 1;
            this.hideAll()
            document.addEventListener('click', this.documentOfferBackgroundClick);

            this.offerBackgroundColor[order - 1].active = true;
        },
        hideofferTextColorPicker() {
            document.removeEventListener('click', this.documentofferTextColorClick);
            this.offerTextColor[0].active = false;
            this.offerTextColor[1].active = false;
            this.offerTextColor[2].active = false;
        },
        hideOfferTextColorPicker() {
            document.removeEventListener('click', this.documentOfferTextColorClick);
            this.iconColor[0].active = false;
            this.iconColor[1].active = false;
            this.iconColor[2].active = false;
        },
        hideOfferBackgroundColorPicker() {
            document.removeEventListener('click', this.documentOfferBackgroundClick);
            this.offerBackgroundColor[0].active = false;
            this.offerBackgroundColor[1].active = false;
            this.offerBackgroundColor[2].active = false;
        },
        hideIconPicker() {
            document.removeEventListener('click', this.documentIconClick);
            this.iconColor[0].active = false;
            this.iconColor[1].active = false;
            this.iconColor[2].active = false;
        },
        hideBackgroundIconPicker() {
            document.removeEventListener('click', this.documentIconClick);
            this.backgroundIconColor[0].active = false;
            this.backgroundIconColor[1].active = false;
            this.backgroundIconColor[2].active = false;
        },

        showBtnTextPicker(order) {
            this.order = order - 1;
            this.hideAll()
            document.addEventListener('click', this.documentBtnTextClick);

            this.btnTextColor[order - 1].active = true;
        },
        hideBtnTextPicker() {
            document.removeEventListener('click', this.documentBtnTextClick);

            this.btnTextColor[0].active = false;
            this.btnTextColor[1].active = false;
            this.btnTextColor[2].active = false;
        },
        showBackgroundColorPicker(order) {
            this.order = order - 1;
            this.hideAll()
            document.addEventListener('click', this.documentBgTextClick);

            this.backgroundColor[order - 1].active = true;
        },
        hideBackgroundColorPicker() {
            document.removeEventListener('click', this.documentBgTextClick);

            this.backgroundColor[0].active = false;
            this.backgroundColor[1].active = false;
            this.backgroundColor[2].active = false;
        },
        hideAll() {
            this.hideBtnPicker();
            this.hidePicker();
            this.hideIconPicker()
            this.hideBackgroundIconPicker()
            this.hideBtnTextPicker();
            this.hideOfferBackgroundColorPicker();
            this.hideofferTextColorPicker();
        },
        documentIconClick(e) {
            if (e.target.id.indexOf('icon-color') === -1 && e.target.className.substr(0, 2) !== 'vc') {
                this.hideIconPicker()
            }
        },
        documentBackgroundIconClick(e) {
            if (e.target.id.indexOf('background-icon-color') === -1 && e.target.className.substr(0, 2) !== 'vc') {
                this.hideBackgroundIconPicker()
            }
        },
        documentOfferTextColorClick(e) {
            if (e.target.id.indexOf('offer-icon-color') === -1 && e.target.className.substr(0, 2) !== 'vc') {
                this.hideofferTextColorPicker()
            }
        },
        documentBgTextClick(e) {
            if (e.target.id.indexOf('btn-background-picker') === -1 && e.target.className.substr(0, 2) !== 'vc') {
                this.hideBackgroundColorPicker()
            }
        },
        documentClick(e) {
            if (e.target.id.indexOf('btn-color-picker') === -1 && e.target.className.substr(0, 2) !== 'vc') {
                this.hidePicker()
            }
        },
        documentBtnClick(e) {
            if (e.target.className.indexOf('second-type') === -1 && e.target.className.substr(0, 2) !== 'vc') {
                this.hideBtnPicker()
            }
        },
        documentOfferBackgroundClick(e) {
            if (e.target.id.indexOf('offer-background-color') === -1 && e.target.className.substr(0, 2) !== 'vc') {
                this.hideOfferBackgroundColorPicker()
            }
        },

        documentBtnTextClick(e) {
            if (e.target.className.indexOf('text-type') === -1 && e.target.className.substr(0, 2) !== 'vc') {
                this.hideBtnTextPicker()
            }
        },

    }
}
</script>

<style scoped lang="scss">

.toggle-header-container {
    display: flex;
    justify-content: space-between;
}

.toggle-btn {
    z-index: 100;
}

.header-title-container {
    display: flex;
    justify-content: space-between;
}

.not-collapsed {
    .arrow-icon {
        transform: rotate(-180deg);
        transition: transform 0.2s linear;
    }
}

.header-container {
    position: relative;
}

.collapsed {
    .arrow-icon {
        transition: transform 0.2s linear;
    }
}

.toggle-button-container {
    position: absolute;
    right: 20px;
    top: 0;
}

.offers-container {
    background: white;
    padding: 20px;
    border-radius: 5px;
    margin-bottom: 20px;
}
.right{
    float: right;
    display: -webkit-box;
    display: -ms-flexbox;
    align-items: center;
}
.form-inline{
    display: block;
}
textarea{
    height: auto!important;
}
.offer-text{
    font-family: inherit;
    font-weight: 500;
    line-height: 1.1;
    color: inherit;
    font-size: 18px;
}
.pointer{
    cursor: pointer;
    height: 25px;
    display: flex;
    justify-content: space-between;
    align-items: center;
    .right{
        display: flex;
    }
}
.edit__set_block{
    padding: 20px;
}
.jscolor-group {
    max-width: 100%;
}
</style>
